var Cc = Components.classes;
var Ci = Components.interfaces;
var Cu = Components.utils;

Components.utils.import("resource://gre/modules/Services.jsm");

var styleSheetService = Components.classes["@mozilla.org/content/style-sheet-service;1"]
        .getService(Components.interfaces.nsIStyleSheetService);

var wm = Cc["@mozilla.org/appshell/window-mediator;1"]
        .getService(Ci.nsIWindowMediator);

var styleSheeUri = Services.io.newURI("chrome://tabdock/content/tabdock.css", null, null);

function loadIntoWindow(window) {
    // Get the anchor for "overlaying" but make sure the UI is loaded
    let browser = window.document.getElementById('browser');

    if(!browser)
        return;

    browser.appendChild(window.document.createElement('fdockTabdock'));

    Components.utils.import('chrome://tabdock/content/tabdock.js');
    new TabDock(window);
}

function unloadFromWindow(window) {

    window.TabDockService.cleanup();

    var tabdock = window.document.getElementById("tabdock");
    if (tabdock)
        tabdock.parentNode.removeChild(tabdock);

    // TODO - need better way of loading / unloading modules
    Components.utils.unload('chrome://tabdock/content/tabdock.js');
    Components.utils.unload('chrome://tabdock/content/preferences/preferences.js');
    Components.utils.unload('chrome://tabdock/content/tabevents.js');
    Components.utils.unload('chrome://tabdock/content/tabdock-settings.js');
    Components.utils.unload('chrome://tabdock/content/tabdock-bookmarks.js');
    Components.utils.unload('chrome://tabdock/content/tabdock-dragdrop.js');
    Components.utils.unload('chrome://tabdock/content/tabgroup/tabgroup.js');
    Components.utils.unload('chrome://tabdock/content/tabpreviews/tabpreviews.js');
    Components.utils.unload('chrome://tabdock/content/tabdock-utils.js');
}

/*
 * Modified from code provided by Mark Finkle
 * http://starkravingfinkle.org/blog/2011/01/bootstrap-jones-adventures-in-restartless-add-ons/
 * 
 * 
 */

var windowListener = {
    onOpenWindow : function(aWindow) {
        // Wait for the window to finish loading
        let
        domWindow = aWindow.QueryInterface(Ci.nsIInterfaceRequestor)
                .getInterface(Ci.nsIDOMWindowInternal || Ci.nsIDOMWindow);
        domWindow.addEventListener("load", function() {
            domWindow.removeEventListener("load", arguments.callee, false);
            loadIntoWindow(domWindow);
        }, false);
    },
    onCloseWindow : function(aWindow) {
    },
    onWindowTitleChange : function(aWindow, aTitle) {
    }
};

function startup(aData, aReason) {
    if (Services.vc.compare(Services.appinfo.platformVersion, "10.0") < 0)
        Components.manager.addBootstrappedManifestLocation(params.installPath);

    // register extension style sheets, chain them using import
    styleSheetService.loadAndRegisterSheet(styleSheeUri, styleSheetService.USER_SHEET);

    // Load into any existing windows
    let enumerator = wm.getEnumerator("navigator:browser");
    while (enumerator.hasMoreElements())
        loadIntoWindow(enumerator.getNext().QueryInterface(Ci.nsIDOMWindow));

    // Load into any new windows
    wm.addListener(windowListener);
}

function shutdown(aData, aReason) {
    // When the application is shutting down we normally don't have to clean up
    // any UI changes
    if (aReason == APP_SHUTDOWN)
        return;

    if (Services.vc.compare(Services.appinfo.platformVersion, "10.0") < 0)
        Components.manager.removeBootstrappedManifestLocation(params.installPath);

    // Stop watching for new windows
    wm.removeListener(windowListener);

    // Unload from any existing windows
    let enumerator = wm.getEnumerator("navigator:browser");
    while (enumerator.hasMoreElements())
        unloadFromWindow(enumerator.getNext().QueryInterface(Ci.nsIDOMWindow));
    
    // unregister extension style sheets
    styleSheetService.unregisterSheet(styleSheeUri, styleSheetService.USER_SHEET);
}

function install(aData, aReason) {
}

function uninstall(aData, aReason) {
}