const EXPORTED_SYMBOLS = ['TabDockSettings'];

Components.utils.import('chrome://tabdock/content/preferences/preferences.js');

TabDockSettings = (function() {
	
	return {
		/** The position: top/bottom/left/right **/
		location: 'top',
	
		/** The orientation of the tabdock */
		orientation: 'horizontal',
			
		/** The direction of popups, related to the orientation */
		popupDirection: 'after_start',
		
		/** Icon size for dock icons, currently only 16 */
		iconsize: 16,
		
	    /** Maps dockmode / location to insert parent */
		insertParentOfLocation : {
	        dock: {
	            top: 'tabdock-overlay-dockmode-before',
	            bottom: 'tabdock-overlay-dockmode-after',
	            left: 'tabdock-overlay-dockmode-before',
                right: 'tabdock-overlay-dockmode-after',
		    },
		    
		    integrated: {
            	top: 'TabsToolbar',
            },
		    
		    normal: {
		        top: 'navigator-toolbox',
	            bottom: 'browser-panel',
	            left: 'browser',
	            right: 'browser', 
		    },
		},
		
		/** Maps dockmode / location to insert anchor */
		insertAnchorOfLocation : {
		    dock: {
	            top: null,
	            bottom: null,
	            left: null,
	            right: null,
            },
            
            integrated: {
            	top: 'tabbrowser-tabs',
            },
            
            normal: {
                top: 'TabsToolbar',
                bottom: null,
                left: 'sidebar-box',
                right: 'browser-border-end',
            },
		},
		
		orientOfLocation : {
			top: 'horizontal',
			bottom: 'horizontal',
			left: 'vertical',
			right: 'vertical',
		},
		
		popupDirectionOfLocation : {
			top: 'after_start',
			bottom: 'before_start',
			left: 'end_after',
			right: 'start_after',
		},
	}
})();
